MODELS -- Start of the MODELS Section

 -- Input Interface at MODELS level : Power Network -> MODELS

 -- Interface from Power Network Cb 1
 INPUT VAG_M1 {TACS(VAG_M1)}
 INPUT VBG_M1 {TACS(VBG_M1)}
 INPUT VCG_M1 {TACS(VCG_M1)}
 INPUT IAP_M1 {TACS(IAP_M1)}
 INPUT IBP_M1 {TACS(IBP_M1)}
 INPUT ICP_M1 {TACS(ICP_M1)}

 -- Interface from Power Network Cb 2
 INPUT VAG_M2 {TACS(VAG_M2)}
 INPUT VBG_M2 {TACS(VBG_M2)}
 INPUT VCG_M2 {TACS(VCG_M2)}
 INPUT IAP_M2 {TACS(IAP_M2)}
 INPUT IBP_M2 {TACS(IBP_M2)}
 INPUT ICP_M2 {TACS(ICP_M2)}
 
  -- Interface from Power Network Cb 3
 INPUT VAG_M3 {TACS(VAG_M3)}
 INPUT VBG_M3 {TACS(VBG_M3)}
 INPUT VCG_M3 {TACS(VCG_M3)}
 INPUT IAP_M3 {TACS(IAP_M3)}
 INPUT IBP_M3 {TACS(IBP_M3)}
 INPUT ICP_M3 {TACS(ICP_M3)}
 
 -- Interface from Power Network Cb 4
 INPUT VAG_M4 {TACS(VAG_M4)}
 INPUT VBG_M4 {TACS(VBG_M4)}
 INPUT VCG_M4 {TACS(VCG_M4)}
 INPUT IAP_M4 {TACS(IAP_M4)}
 INPUT IBP_M4 {TACS(IBP_M4)}
 INPUT ICP_M4 {TACS(ICP_M4)}
 
 -- Interface from Power Network Cb 5
 INPUT VAG_M5 {TACS(VAG_M5)}
 INPUT VBG_M5 {TACS(VBG_M5)}
 INPUT VCG_M5 {TACS(VCG_M5)}
 INPUT IAP_M5 {TACS(IAP_M5)}
 INPUT IBP_M5 {TACS(IBP_M5)}
 INPUT ICP_M5 {TACS(ICP_M5)}
  
 -- Interface from Power Network Prb 1
 INPUT APV001 {TACS(APV001)}
 INPUT BPV001 {TACS(BPV001)}
 INPUT CPV001 {TACS(CPV001)}
 INPUT API001 {TACS(API001)}
 INPUT BPI001 {TACS(BPI001)}
 INPUT CPI001 {TACS(CPI001)}
 
 -- Interface from Power Network Prb 2
 INPUT APV002 {TACS(APV002)}
 INPUT BPV002 {TACS(BPV002)}
 INPUT CPV002 {TACS(CPV002)}
 INPUT API002 {TACS(API002)}
 INPUT BPI002 {TACS(BPI002)}
 INPUT CPI002 {TACS(CPI002)}

 -- Output Interface at MODELS level: MODELS -> Power Network
 OUTPUT CTRL1       -- TRIP-Command from Instance MeasLoc1
 OUTPUT CTRL2       -- TRIP-Command from Instance MeasLoc2
 OUTPUT CTRL3       -- TRIP-Command from Instance MeasLoc3
 OUTPUT CTRL4       -- TRIP-Command from Instance MeasLoc4
 OUTPUT CTRL5       -- TRIP-Command from Instance MeasLoc5
 OUTPUT CTRL6       -- TRIP-Command from Instance MeasLoc6
 OUTPUT CTRL7       -- TRIP-Command from Instance MeasLoc7

 
 -- Model of a simple OC protection realy
 MODEL Protection

  -- Input Interface at MODEL level : MODELS -> MODEL source code
  INPUT API  -- Current Phase IA
  INPUT BPI  -- Current Phase IB
  INPUT CPI  -- Current Phase IC

  INPUT APV  -- Phase-to-Ground Voltage VAG 
  INPUT BPV  -- Phase-to-Ground Voltage VBG 
  INPUT CPV  -- Phase-to-Ground Voltage VCG 

  -- Output Interface at MODEL level: MODEL source code -> MODELS
  OUTPUT
   TripCommand  -- TRIP-Command to the Circuit-Breaker / Switch

  CONST PowerNetFreq {val: 50}  -- POWER FREQUENCY [Hz]
  CONST PowerNetCycle {val: 0.02}  -- Cycle [s]
  CONST SamplingFreq {val: 1000}  -- Sampling Frequency [Hz]
  CONST SamplingDT {val: 0.001}  -- Sampling Rate [s]
  CONST SamplesPerCycle {val: 20}  -- Samples per Cycle

  DATA Ig1Setting {dflt: 1.0e10}  -- Starting threshold in A
  DATA T1Setting {dflt: 0.0} -- Delay time in s
  DATA CBDelayTime {dflt: 0.1} -- Delay time of the circuit-breaker in s
  DATA MeasLocation {dflt: -1.0} -- ID of the measuring location
  
  CONST CBTIMEENABLED {val: 4.0}
  CONST TIMEENABLED {val: 2.0}
  CONST DISABLED {val: 0.0}

  -- Declaration of all variables
  VAR
   
   -- = 0 (Closed) : CB keeps closed
   -- = 1 (Open) : CB will be opened
   TripCommand
   
   -- Current time delay after starting in s
   T1Delay, CBDelay
   
   -- Starting signal
   T1Enabled, CBEnabled
   
   -- Sampled values of the last cycle
   APIBuffer [0..(SamplesPerCycle - 1)]
   BPIBuffer [0..(SamplesPerCycle - 1)]
   CPIBuffer [0..(SamplesPerCycle - 1)]
   
   -- Filter coiefficients (Discrete Fourier Analysis)
   CosKoeff [0..(SamplesPerCycle - 1)]
   SinKoeff [0..(SamplesPerCycle - 1)]
   
   -- Phasors of the phase currents in A
   -- Re=Real part, Im=Imaginary part
   -- Amount in A, Phase in Degree
   APIRe, APIIm
   BPIRe, BPIIm
   CPIRe, CPIIm
   APIAmount, APIPhase
   BPIAmount, BPIPhase
   CPIAmount, CPIPhase
   
   Omega -- Angular Frequency in Hz
   
  -- One-time initialization of variables, etc. at simulation start
  INIT
 
   -- CB closed
   TripCommand := Closed
   
   for i := 0 to (SamplesPerCycle - 1) do
    APIBuffer [i] := 0.0
    BPIBuffer [i] := 0.0
    CPIBuffer [i] := 0.0
   endfor
   
   APIRe := 0.0
   APIIm := 0.0
   BPIRe := 0.0
   BPIIm := 0.0
   CPIRe := 0.0
   CPIIm := 0.0
   APIAmount := 0.0
   APIPhase := 0.0
   BPIAmount := 0.0
   BPIPhase := 0.0
   CPIAmount := 0.0
   CPIPhase := 0.0
   T1Delay := 0.0
   T1Enabled := DISABLED
   CBDelay := 0.0
   CBEnabled := DISABLED
   Omega := 2.0 * pi * PowerNetFreq

   -- Calcualtion of DFT Filter Coefficients
   for i := 0 to (SamplesPerCycle - 1) do
    CosKoeff[i] := cos(Omega * SamplingDT * i)
    SinKoeff[i] := sin(Omega * SamplingDT * i)
   endfor

  ENDINIT

  -- Execution at each simulation time step
  EXEC
  
   -- Shifting the sampled values one time step to the past
   for i := 0 to (SamplesPerCycle - 2)
   do
    APIBuffer[i] := APIBuffer[i+1]
    BPIBuffer[i] := BPIBuffer[i+1]
    CPIBuffer[i] := CPIBuffer[i+1]
   endfor
  
   -- Insert the new sampled value
   APIBuffer[SamplesPerCycle - 1] := API
   BPIBuffer[SamplesPerCycle - 1] := BPI
   CPIBuffer[SamplesPerCycle - 1] := CPI
   
   -- Reset variables
   APIRe := 0.0
   APIIm := 0.0
   BPIRe := 0.0
   BPIIm := 0.0
   CPIRe := 0.0
   CPIIm := 0.0

   -- Processing the DFT for the last cycle
   for i := 0 to (SamplesPerCycle - 1) do
    APIRe := APIRe + APIBuffer[i] * CosKoeff[i]
    APIIm := APIIm + APIBuffer[i] * SinKoeff[i]
    BPIRe := BPIRe + BPIBuffer[i] * CosKoeff[i]
    BPIIm := BPIIm + BPIBuffer[i] * SinKoeff[i]
    CPIRe := CPIRe + CPIBuffer[i] * CosKoeff[i]
    CPIIm := CPIIm + CPIBuffer[i] * SinKoeff[i]
   endfor
  
   APIRe := APIRe * 2.0 / SamplesPerCycle
   APIIm := APIIm * 2.0 / SamplesPerCycle
   BPIRe := BPIRe * 2.0 / SamplesPerCycle
   BPIIm := BPIIm * 2.0 / SamplesPerCycle
   CPIRe := CPIRe * 2.0 / SamplesPerCycle
   CPIIm := CPIIm * 2.0 / SamplesPerCycle

   -- Peak value of the fundamental frequency
   APIAmount := sqrt((APIRe * APIRe) + (APIIm * APIIm))
   BPIAmount := sqrt((BPIRe * BPIRe) + (BPIIm * BPIIm))
   CPIAmount := sqrt((CPIRe * CPIRe) + (CPIIm * CPIIm))
   
	-- Starting signal: if YES, start of the time delay
   if ((APIAmount > Ig1Setting) or
       (BPIAmount > Ig1Setting) or
	   (CPIAmount > Ig1Setting))
      and
	  (T1Enabled = DISABLED)
   then
    
	-- Starting time of the time delay in s
	T1Delay := t
	T1Enabled := TIMEENABLED
	
    -- Reset time delay of circuit-breaker
	CBDelay := 0.0
	CBEnabled := DISABLED
	
	write ("Starting signal: t=", t, " MLoc=", MeasLocation,
	        " T1Enabled=", T1Enabled, " T1Delay=", T1Delay)
	
   endif
   
   -- Reset starting signal
   if ((APIAmount < Ig1Setting)  and
       (BPIAmount < Ig1Setting)  and
	   (CPIAmount < Ig1Setting))
	  and 
      (T1Enabled = TIMEENABLED)
   then
	  
     -- Reset time delay
	 T1Delay := 0.0
	 T1Enabled := DISABLED

	 -- Reset also time delay of circuit-breaker
	 CBDelay := 0.0
	 CBEnabled := DISABLED

	 write ("Reset starting signal: t=", t, " MLoc=", MeasLocation,
	        " T1Enabled=", T1Enabled, " T1Delay=", T1Delay)
    
   endif

   -- Starting time delay of circuit-breaker
   if ((t - T1Delay) >= T1Setting) and
	  (T1Enabled = TIMEENABLED) and
	  (CBEnabled = DISABLED)
   then

     -- Starting time delay of the circuit breaker in s
	 CBDelay := t
	 CBEnabled := CBTIMEENABLED
	
	 write ("CB starting signal: t=", t, " MLoc=", MeasLocation,
	        " T1Enabled=", T1Enabled, " T1Delay=", T1Delay,
			" CBEnabled=", CBEnabled, " CBDelay=", CBDelay)

   endif
   
   -- Generate TRIP command
   if (CBEnabled = CBTIMEENABLED) and
      (T1Enabled = TIMEENABLED) and
      ((t - CBDelay) >= CBDelayTime)
   then

    -- TRIP-Kommando
	TripCommand := Open
	
	-- Reset time delay
	T1Delay := 0.0
	T1Enabled := DISABLED

	-- Reset also time delay of circuit-breaker
	CBDelay := 0.0
	CBEnabled := DISABLED
	
   endif
	
  ENDEXEC

 ENDMODEL
 -- End of the MODEL implementation (source code)

 -- Start of the MODEL instance (task)
  USE Protection AS MeasLoc1
 
  -- Phase Current A, B, C
  INPUT API := IAP_M1
  INPUT BPI := IBP_M1
  INPUT CPI := ICP_M1

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := VAG_M1
  INPUT BPV := VBG_M1
  INPUT CPV := VCG_M1
  
  -- TRIP-Command
  OUTPUT CTRL1 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.3
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 1

 ENDUSE -- End of the MODEL instance (task)
 
 -- Start of the MODEL instance (task)
  USE Protection AS MeasLoc2
 
  -- Phase Current A, B, C
  INPUT API := IAP_M2
  INPUT BPI := IBP_M2
  INPUT CPI := ICP_M2

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := VAG_M2
  INPUT BPV := VBG_M2
  INPUT CPV := VCG_M2
  
  -- TRIP-Command
  OUTPUT CTRL2 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.3
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 2

 ENDUSE -- End of the MODEL instance (task)
 
 -- Start of the MODEL instance (task)
  USE Protection AS MeasLoc3
 
  -- Phase Current A, B, C
  INPUT API := IAP_M3
  INPUT BPI := IBP_M3
  INPUT CPI := ICP_M3

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := VAG_M3
  INPUT BPV := VBG_M3
  INPUT CPV := VCG_M3
  
  -- TRIP-Command
  OUTPUT CTRL3 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.2
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 3

 ENDUSE -- End of the MODEL instance (task)
 
 -- Start of the MODEL instance (task)
  USE Protection AS MeasLoc4
 
  -- Phase Current A, B, C
  INPUT API := IAP_M4
  INPUT BPI := IBP_M4
  INPUT CPI := ICP_M4

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := VAG_M4
  INPUT BPV := VBG_M4
  INPUT CPV := VCG_M4
  
  -- TRIP-Command
  OUTPUT CTRL4 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.2
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 4

 ENDUSE -- End of the MODEL instance (task)
 
 -- Start of the MODEL instance (task)
  USE Protection AS MeasLoc5
 
  -- Phase Current A, B, C
  INPUT API := IAP_M5
  INPUT BPI := IBP_M5
  INPUT CPI := ICP_M5

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := VAG_M5
  INPUT BPV := VBG_M5
  INPUT CPV := VCG_M5
  
  -- TRIP-Command
  OUTPUT CTRL5 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.1
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 5

 ENDUSE -- End of the MODEL instance (task)
 
  -- Start of the MODEL instance (task)
  USE Protection AS MeasLoc6
 
  -- Phase Current A, B, C
  INPUT API := API001
  INPUT BPI := BPI001
  INPUT CPI := CPI001

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := APV001
  INPUT BPV := BPV001
  INPUT CPV := CPV001
  
  -- TRIP-Command
  OUTPUT CTRL6 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.1
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 6

 ENDUSE -- End of the MODEL instance (task)
 
   -- Start of the MODEL instance (task)
 USE Protection AS MeasLoc7
 
  -- Phase Current A, B, C
  INPUT API := API002
  INPUT BPI := BPI002
  INPUT CPI := CPI002

  -- Phase-to-Ground Voltages A, B, C
  INPUT APV := APV002
  INPUT BPV := BPV002
  INPUT CPV := CPV002
  
  -- TRIP-Command
  OUTPUT CTRL7 := TripCommand
  
  -- Settings
  DATA Ig1Setting := 1000.0
  DATA T1Setting := 0.1
  DATA CBDelayTime := 0.05
  DATA MeasLocation := 7

 ENDUSE -- End of the MODEL instance (task)

 RECORD
  MeasLoc1.T1Enabled AS CB1ENA
  MeasLoc1.CBEnabled AS CB1T1G
  MeasLoc1.TripCommand AS CB1TRP
  MeasLoc2.T1Enabled AS CB2ENA
  MeasLoc2.CBEnabled AS CB2T1G
  MeasLoc2.TripCommand AS CB2TRP
  MeasLoc3.T1Enabled AS CB3ENA
  MeasLoc3.CBEnabled AS CB3T1G
  MeasLoc3.TripCommand AS CB3TRP
  MeasLoc4.T1Enabled AS CB4ENA
  MeasLoc4.CBEnabled AS CB4T1G
  MeasLoc4.TripCommand AS CB4TRP
  MeasLoc5.T1Enabled AS CB5ENA
  MeasLoc5.CBEnabled AS CB5T1G
  MeasLoc5.TripCommand AS CB5TRP
  MeasLoc6.T1Enabled AS CB6ENA
  MeasLoc6.CBEnabled AS CB6T1G
  MeasLoc6.TripCommand AS CB6TRP
  MeasLoc7.T1Enabled AS CB7ENA
  MeasLoc7.CBEnabled AS CB7T1G
  MeasLoc7.TripCommand AS CB7TRP

ENDMODELS -- End of the MODELS Section
